routes/admin.php
<?php

/*
|--------------------------------------------------------------------------
| Admin Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Guest area
Route::get('', 'Admin\AuthController@loginForm');
Route::get('login', 'Admin\AuthController@loginForm')->name('admin.login.index');
Route::post('login', 'Admin\AuthController@login')->name('admin.do-login');

// Reset  password
Route::get('/forgot-password', 'Admin\ForgotPasswordController@showLinkRequestForm')->name('admin.forgot-password.index');
Route::post('/forgot-password/email', 'Admin\ForgotPasswordController@sendResetLinkEmail')->name('admin.forgot-password.action');
Route::get('/reset-password/{token}', 'Admin\ResetPasswordController@showResetForm')->name('admin.reset-password.index');
Route::post('/reset-password', 'Admin\ResetPasswordController@reset')->name('admin.reset-password.action');
Route::get('/delete/{id}','Admin\AdminAccountController@DeleteStaff')->name('admin.staff.delete');
Route::get('/settings','Admin\SettingController@index')->name('settings.index');
Route::post('/settings','Admin\SettingController@store')->name('settings.store');
// Hotel admin area
Route::group(['middleware' => 'admin'], function () {
    Route::get('logout', 'Admin\AuthController@logout')->name('admin.logout.index');
    Route::get('dashboard', 'Admin\DashboardController@index')->name('admin.dashboard.index');

    Route::resource('hotels', 'Admin\HotelController', [
        'as' => 'admin',
        'only' => ['index', 'show', 'update', 'create', 'store']
    ]);
    Route::get('/deletehotel/{id}','Admin\HotelController@destroy')->name('admin.hotel.destroy');
    Route::resource('hotel-features', 'Admin\HotelFeatureController', [
        'as' => 'admin',
        'only' => ['update']
    ]);

    // Datatables
    Route::group(['prefix' => 'data-tables'], function () {
        Route::get('hotels', 'Admin\HotelController@indexDataTable')->name('data-tables.admin.hotels');
    });

    Route::get('/staff','Admin\AdminAccountController@index')->name('staff.index');
    Route::post('/staff','Admin\AdminAccountController@create')->name('staff.create');

    // Ajax
    Route::group(['prefix' => 'ajax'], function () {
        Route::get('hotel-features', 'Admin\HotelFeatureController@ajaxGetHotelFeatures')->name('ajax.admin.hotel-features.index');
        Route::put('hotel-features/{hotel}', 'Admin\HotelFeatureController@ajaxUpdateHotelFeature')->name('ajax.admin.hotel-features.update');
    });

});

routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('', function () {
    return view('welcome', [
        'title' => 'Web ' . env('APP_NAME') . 'Testing'
    ]);
});

app/Http/Controllers/Admin/HotelController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Requests\StoreHotelRequest;
use App\Models\Hotel;
use App\Models\HotelFeature;
use App\Models\PassportPhoto;
use App\Models\Spa;
use App\Services\HotelBookingService;
use App\Services\HotelService;
use App\Services\SendbirdService;
use Carbon\Carbon;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Yajra\DataTables\DataTables;
use Illuminate\Support\Facades\Redirect;

class HotelController extends Controller
{
    private $hotelService;

    public function __construct(HotelService $hotelService)
    {
        $this->hotelService = $hotelService;
    }

    public function index()
    {
        return view('admin.hotel.index');
    }

    /**
     * Process data tables ajax request.
     *
     * @param Request $request
     * @return \Illuminate\Http\JsonResponse
     * @throws \Exception
     */
    public function indexDataTable(Request $request)
    {
        // Create query
        $query = Hotel::query();

        return Datatables::of($query)
            ->addIndexColumn()
            ->make(true);
    }

    public function show(Hotel $hotel)
    {
        $hotel->load('hotelFeature');
        if (!$hotel->hotelFeature) {
            // Create hotel feature
            HotelFeature::create([
                'hotel_id' => $hotel->id,
                'is_check_in_enabled' => true,
                'is_check_out_enabled' => true,
                'is_spa_enabled' => true,
                'is_restaurant_enabled' => true,
                'is_concierge_enabled' => true,
                'is_cleaning_enabled' => true,
                'spa_treatment' => true,
                'spa_room_service' => true,
                'is_experience' => true
            ]);
            $hotel->load('hotelFeature');

            // Create mobile layout
            MobileLayout::create([
                'hotel_id' => $hotel->id,
                'mobile_hotel_theme_id' => 1,
                'mobile_hotel_icon_id' => 1,
            ]);

            if (!$hotel->sendbird_user_id) {
                $sendbirdService = new SendbirdService();
                $sendbirdHotel = $sendbirdService->createHotelUser($hotel);
                $hotel->sendbird_user_id = $sendbirdHotel->user_id;
                $hotel->sendbird_access_token = $sendbirdHotel->access_token;
                $hotel->save();
            }
        }

        return view('admin.hotel.show', [
            'hotel' => $hotel,
        ]);
    }

    /**
     * @param Request $request
     * @param Hotel $hotel
     * @return \Illuminate\Http\RedirectResponse
     * @throws \Exception
     */
    public function update(Request $request, Hotel $hotel)
    {
        $updateType = $request->get('type', 'renew');
        $updateMonthTime  =$request->get('extendmonthTime');
        switch ($updateType) {
            case 'inactive':
                $hotel->is_active = false;
                $hotel->save();
                return redirect()->route('admin.hotels.show', ['hotel' => $hotel->id])->with('success', 'Inactive success.');

                break;
            default:
                $expiredAt = Carbon::create($hotel->expired_at);

                if ($expiredAt->isPast()) {
                    $hotel->expired_at = now()->addMonth($updateMonthTime);
                } else {
                    $hotel->expired_at = $expiredAt->addMonth($updateMonthTime);
                }
                $hotel->is_active = true;

                $hotel->save();
                return redirect()->route('admin.hotels.show', ['hotel' => $hotel->id])->with('success', 'Renew success.');
                break;
        }
    }

    public function create()
    {
        return view('admin.hotel.create');
    }

    public function store(StoreHotelRequest $request)
    {
        $sendbirdService = new SendbirdService();
        $data = $request->only([
            'code',
            'email',
            'username',
            'password',
            'name',
            'phone_number',
        ]);

        $hotel = null;
        DB::transaction(function () use ($data, &$hotel, $sendbirdService) {
            $hotel = $this->hotelService->store($data);
            $sendbirdHotel = $sendbirdService->createHotelUser($hotel);
            $hotel->sendbird_user_id = $sendbirdHotel->user_id;
            $hotel->sendbird_access_token = $sendbirdHotel->access_token;
            $hotel->save();

            HotelFeature::create([
                'hotel_id' => $hotel->id,
                'is_check_in_enabled' => true,
                'is_check_out_enabled' => true,
                'is_spa_enabled' => true,
                'is_restaurant_enabled' => true,
                'is_concierge_enabled' => true,
                'is_cleaning_enabled' => true,
                'spa_treatment' => true,
                'spa_room_service' => true,
                'is_experience' => true
            ]);

            $spa = Spa::firstOrCreate(
                ['hotel_id' => $hotel->id],
                ['name' => 'Your spa', 'logo_url' => 'https://servrhotels.s3-ap-southeast-1.amazonaws.com/spas/default.png']
            );
        });
        return redirect()->route('admin.hotels.show', ['hotel' => $hotel->id])->with('success', 'Create hotel success.');

        // For demo only
        // Create 1 checkin request
        $bookingData = [
            'hotel_id' => $hotel->id,
            'arrival_date' => now()->addDays(3)->toDateTimeString(),
            'departure_date' => now()->addDays(5)->toDateTimeString(),
            'cardholder_name' => 'John Doe',
            'card_expiry_date' => '2024-12-31',
            'card_number' => '4242424242424242',
            'card_address' => 'Bali',
            'phone_number' => '+628123456789',
            'reference' => null,
        ];
        $hotelBookingService = new HotelBookingService();
        $booking = $hotelBookingService->create($bookingData);
        PassportPhoto::create([
            'hotel_booking_id' => $booking->id,
            'url' => 'https://upload.wikimedia.org/wikipedia/en/4/44/Interpolpassportpage.png',
        ]);
        PassportPhoto::create([
            'hotel_booking_id' => $booking->id,
            'url' => 'https://upload.wikimedia.org/wikipedia/commons/e/e3/New_Zealand_Diplomatic_Passport_Biodata_Page.png',
        ]);
        $sendbirdUser = $sendbirdService->createBookingUser($booking);
        $sendbirdChannel = $sendbirdService->createChatChannel($booking);
        $booking->sendbird_user_id = $sendbirdUser->user_id;
        $booking->sendbird_access_token = $sendbirdUser->access_token;
        $booking->sendbird_channel_url = $sendbirdChannel->channel_url;
        $booking->save();

        return redirect()->route('admin.hotels.show', ['hotel' => $hotel->id])->with('success', 'Create hotel success.');
    }

    public function destroy(Request $request)
    {
        $hotel = Hotel::where('id', $request->id)->delete();
        $id = $request->id;
        
        return Redirect::back()->with('success', 'Staff member added successfully.');
    }
}

app/Http/Controllers/Api/HotelController.php
<?php

namespace App\Http\Controllers\Api;

use App\Services\HotelService;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\MobileHotelLayout;

class HotelController extends Controller
{
    protected $hotelService;

    public function __construct(HotelService $hotelService)
    {
        $this->hotelService = $hotelService;
    }

    public function getByCode(Request $request)
    {
        $hotelCode = $request->code;

        $hotel = $this->hotelService->getByCode($hotelCode);
        // if (!$hotel->mobile_hotel_layout_id) {
        //     $hotel->mobile_hotel_layout_id=1;
        //     $hotel->save();
        // }
        $mobileHotelTheme = $hotel->mobileHotelTheme;
        $mobileHotelLayout = MobileHotelLayout::where('hotel_id', $hotel->id)->orWhere('hotel_id', 0)->get();
        $hotelFeature = $hotel->hotelFeature;

        return response()->json([
            'message' => 'Get hotel success',
            'data' => [
                'id' => $hotel->id,
                'code' => $hotel->code,
                'name' => $hotel->name,
                'description' => $hotel->description,
                'hotel_logo_lg' => $hotel->hotel_logo_lg,
                'hotel_logo_md' => $hotel->hotel_logo_md,
                'hotel_logo_sm' => $hotel->hotel_logo_sm,
                'currency' => $hotel->currency,
                'category' => $hotel->category,
                'layout' => [
                    'theme' => [
                        'primary_color' => $mobileHotelTheme->primary_color,
                        'secondary_color' => $mobileHotelTheme->secondary_color,
                    ],
                    'icons' => [
                        'check_in_color' => $mobileHotelTheme->check_in_color,
                        'check_out_color' => $mobileHotelTheme->check_out_color,
                        'restaurant_color' => $mobileHotelTheme->restaurant_color,
                        'spa_color' => $mobileHotelTheme->spa_color,
                        'concierge_color' => $mobileHotelTheme->concierge_color,
                        'cleaning_color' => $mobileHotelTheme->cleaning_color,
                    ],
                ],
                'mobile_hotel_layouts' =>$mobileHotelLayout,
                'hotel_features' => [
                    'is_check_in_enabled' => $hotelFeature->is_check_in_enabled,
                    'is_check_out_enabled' => $hotelFeature->is_check_out_enabled,
                    'is_spa_enabled' => $hotelFeature->is_spa_enabled,
                    'is_restaurant_enabled' => $hotelFeature->is_restaurant_enabled,
                    'is_concierge_enabled' => $hotelFeature->is_concierge_enabled,
                    'is_cleaning_enabled' => $hotelFeature->is_cleaning_enabled,
                    'is_spa_treatment' => $hotelFeature->spa_treatment,
                    'is_spa_room_service' => $hotelFeature->spa_room_service,
                    'is_experience' => $hotelFeature->is_experience
                ],
            ],
        ]);
    }
}

app/Http/Controllers/Cms/AppearanceController.php
<?php

namespace App\Http\Controllers\Cms;

use App\Models\MobileHotelTheme;
use App\Models\MobileHotelLayout;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class AppearanceController extends Controller
{
    public function index()
    {
        $hotel = auth('hotel')->user();
        $mobileHotelThemes = MobileHotelTheme::all();
        $mobileHotelLayout = MobileHotelLayout::where(function ($query) use ($hotel) {
            $query->where('hotel_id', '=', $hotel->id)
          ->orWhere('hotel_id', '=', 0);
        })->get();


        return view('cms.appearance.index', [
            'hotel' => $hotel,
            'mobileHotelThemes' => $mobileHotelThemes,
            'mobileHotelLayouts'=>$mobileHotelLayout
        ]);
    }
}

app/Http/Controllers/Cms/AuthController.php
<?php

namespace App\Http\Controllers\Cms;

use App\Http\Requests\LoginAdminRequest;
use App\Http\Requests\LoginHotelAdminRequest;
use App\Models\Admin;
use App\Http\Controllers\Controller;
use App\Models\Hotel;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Redirect;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;
use Illuminate\Http\Request;
use App\Models\Hotel_Staff;
use App\Models\User;

class AuthController extends Controller
{
    public function loginForm()
    {
        if (auth('hotel')->check()) {
            return redirect()->route('cms.dashboard.index');
        }
        $for = "hotel_admin";
        if (\Request::route()->getName() === "cms.staff_login.index") {
            $for = "hotel_staff";
        }
        return view('cms.auth.login.index', [
            'for' => $for]);
        return view('cms.auth.login.index');
    }

    public function login(LoginHotelAdminRequest $request)
    {
        // check hotel membership expired or not
        $hotels = Hotel::where('expired_at', '<=', Carbon::now())->get();

        foreach ($hotels as $key => $hotel) {
            $hotel->is_active = 0;
            $hotel->save();
        }
        //

        $credentials = [
            'email' => $request->email,
            'password' => $request->password,
        ];

        if (Auth::guard('hotel')->attempt($credentials)) {
            $hotel=Hotel::where('id', Auth::guard('hotel')->user()->id)->first();
            return redirect()->route('cms.dashboard.index');
        }

        return Redirect::back()->withInput()->with('error', 'Incorrect credentials!.');
    }

    public function staff_login(Request $request)
    {
        $hotels = Hotel::where('expired_at', '<=', Carbon::now())->get();

        foreach ($hotels as $key => $hotel) {
            $hotel->is_active = 0;
            $hotel->save();
        }
        
        $email = $request->input('email');
        $password = $request->input('password');
        $validUser = Hotel_Staff::where([['email','=',$email],['password','=',$password]])->first();
        
        //dd(DB::getQueryLog()); // Show results of log
        if (!$validUser) {
            return Redirect::back()->withInput()->with('error', 'Incorrect credentials!.');
        }
        $hotel_account = Hotel::where('id', $validUser->hotel_id)->first();
        Auth::guard('hotel')->login($hotel_account);
        Auth::guard('hotel_staff')->login($validUser);
        return redirect()->route('cms.dashboard.index');
    }

    public function logout()
    {
        Auth::guard('hotel')->logout();
        if (auth('hotel_staff')->user()) {
            Auth::guard('hotel_staff')->logout();
        }
        return redirect()->route('cms.login.index');
    }
}

app/Http/Controllers/Cms/ConciergeServiceRequestController.php
<?php

namespace App\Http\Controllers\Cms;

use App\Models\ConciergeServiceRequest;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class ConciergeServiceRequestController extends Controller
{
    public function update(Request $request)
    {
        ConciergeServiceRequest::where('id', $request->get('concierge_service_request_id', 0))
            ->update([
                'status' => $request->get('status', 'done')
            ]);

        return redirect()->route('cms.concierges.index')->with('success', 'Success');
    }
}

resources/views/cms/hotel/create.blade.php
@extends('cms.layouts.auth')

@section('title', __('Register Hotel'))

@section('content')
    <div id="register_wrapper" class="row justify-content-center">
        <div class="col-xl-5 col-lg-6 col-md-8 col-sm-10">
            <div class="card-group">
                <div class="card p-4">
                    <div class="card-body">
                        <div class="admin-panel-text">
                            <h2>{{ env('APP_NAME') }}</h2>
                            <h3>{{ __('Register hotel') }}</h3>
                        </div>
                        <form id="registerForm" class="form-horizontal" action="{{ route('cms.hotels.store') }}" method="post">
                            @csrf()
                            @method('post')
                            <div class="form-group row">
                                <div class="col-md-12">
                                    <div class="input-group">
                                        <input class="form-control {{ $errors->has('code') ? ' is-invalid' : '' }}" id="code" type="text" name="code" placeholder="Code. E.g. LUXURYHOTEL" style="text-transform:uppercase" value="{{ old('code') ? old('code') : '' }}">
                                        @if ($errors->has('code'))
                                            <span class="invalid-feedback" role="alert">
                                                <strong>{{ $errors->first('code') }}</strong>
                                            </span>
                                        @endif
                                    </div>
                                </div>
                            </div>

                            <div class="form-group row">
                                <div class="col-md-12">
                                    <div class="input-group">
                                        <input class="form-control {{ $errors->has('username') ? ' is-invalid' : '' }}" id="username" type="text" name="username" placeholder="Username" style="text-transform:lowercase" value="{{ old('username') ? old('username') : '' }}">
                                        @if ($errors->has('username'))
                                            <span class="invalid-feedback" role="alert">
                                                <strong>{{ $errors->first('username') }}</strong>
                                            </span>
                                        @endif
                                    </div>
                                </div>
                            </div>
                            <div class="form-group row">
                                <div class="col-md-12">
                                    <div class="input-group">
                                        <input class="form-control {{ $errors->has('name') ? ' is-invalid' : '' }}" id="name" type="text" name="name" placeholder="Hotel name" value="{{ old('name') ? old('name') : '' }}">
                                        @if ($errors->has('name'))
                                            <span class="invalid-feedback" role="alert">
                                                <strong>{{ $errors->first('name') }}</strong>
                                            </span>
                                        @endif
                                    </div>
                                </div>
                            </div>
                            <div class="form-group row">
                                <div class="col-md-12">
                                    <div class="input-group">
                                        <input class="form-control {{ $errors->has('description') ? ' is-invalid' : '' }}" id="description" type="text" name="description" placeholder="Hotel description" value="{{ old('description') ? old('description') : '' }}">
                                        @if ($errors->has('description'))
                                            <span class="invalid-feedback" role="alert">
                                                <strong>{{ $errors->first('description') }}</strong>
                                            </span>
                                        @endif
                                    </div>
                                </div>
                            </div>
                            <div class="form-group row">
                                <div class="col-md-12">
                                    <div class="input-group">
                                        <input class="form-control {{ $errors->has('email') ? ' is-invalid' : '' }}" id="email" type="email" name="email" placeholder="Email" value="{{ old('email') ? old('email') : '' }}">
                                        @if ($errors->has('email'))
                                            <span class="invalid-feedback" role="alert">
                                                <strong>{{ $errors->first('email') }}</strong>
                                            </span>
                                        @endif
                                    </div>
                                </div>
                            </div>
                            <div class="form-group row">
                                <div class="col-md-12">
                                    <div class="input-group">
                                        <input class="form-control {{ $errors->has('password') ? ' is-invalid' : '' }}" id="password" type="password" name="password" placeholder="Password">
                                        <span class="fa fa-fw fa-eye-slash field-icon toggle-password"></span>
                                        @if ($errors->has('password'))
                                            <span class="invalid-feedback" role="alert">
                                                <strong>{{ $errors->first('password') }}</strong>
                                            </span>
                                        @endif
                                    </div>
                                </div>
                            </div>
                            <div class="form-group row">
                                <div class="col-md-12">
                                    <div class="input-group">
                                        <input class="form-control {{ $errors->has('password_confirmation') ? ' is-invalid' : '' }}" id="password_confirmation" type="password" name="password_confirmation" placeholder="Password confirm.">
                                        <span class="fa fa-fw fa-eye-slash field-icon toggle-password-confirm"></span>
                                        @if ($errors->has('password_confirm'))
                                            <span class="invalid-feedback" role="alert">
                                                <strong>{{ $errors->first('password_confirmation') }}</strong>
                                            </span>
                                        @endif
                                    </div>
                                </div>
                            </div>
                        </form>
                        <div class="row">
                            <div class="col-12">
                                <button class="btn btn-pill btn-block btn-primary" type="button" id="buttonRegister" disabled>{{ __('Register') }}</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@stop

@section('js')
    <script>
        const url1 = '{!! route('cms.dashboard.index') !!}';
    </script>
    <script src="{{ asset('js/custom/cms/hotel.js') }}"></script>
@stop

resources/views/cms/hotel/response.blade.php
@extends('cms.layouts.auth')

@section('title', __('Success register hotel'))

@section('content')
    <div id="registerHotelResponseWrapper" class="row justify-content-center">
        <div class="col-xl-6 col-lg-8 col-md-8 col-sm-10">
            <div class="card-group">
                <div class="card p-4">
                    <div class="card-body">
                        <div class="admin-panel-text">
                            <h2>{{ env('APP_NAME') }}</h2>
                            <h3>{{ __('Register hotel') }}</h3>
                        </div>

                        <div class="row responseWrapper">
                            <div class="col-12">
                                <h4>{{ $response }}</h4>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@stop